#include "stdafx.h"
#include "AlexfHistogram.h"
#include "AlexfStaticHistogram.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CAlexfStaticHistogram::CAlexfStaticHistogram()
{
	m_bOK = FALSE;
	m_lTextLines = 0;
	m_lTextWidth = 0;
	m_lStack = 0;
	m_dMaxValue = 1;

	m_lArraySize = GetSystemMetrics(SM_CXSCREEN);
	
	myHistogram = new DOUBLE[m_lArraySize];		//This creates the array on the heap.
	
	if (!myHistogram) return;
	ZeroMemory(myHistogram, m_lArraySize * sizeof(DOUBLE));
	m_bOK = TRUE;
}

CAlexfStaticHistogram::~CAlexfStaticHistogram()
{
	if (myHistogram) delete [] myHistogram;
}


BEGIN_MESSAGE_MAP(CAlexfStaticHistogram, CStatic)
	ON_WM_PAINT()
END_MESSAGE_MAP()

void CAlexfStaticHistogram::OnPaint() 
{
	if (!m_bOK)
	{
		CStatic::OnPaint();
		return;
	}
	CPaintDC dc(this); 
	CRect cr;
	GetClientRect(&cr);
	if (m_bNeedFullRedraw)
	{
		m_bNeedFullRedraw = FALSE;
		dc.FillRect(cr, & CBrush(GetSysColor(COLOR_BTNFACE)));
	}
	CRect cr1(cr);
	if (m_bTextLeft) cr1.right = cr1.left + m_lTextWidth;
	else cr1.left = cr1.right - m_lTextWidth;
// text
	dc.SetBkMode(TRANSPARENT);
	dc.SetTextColor(GetSysColor(COLOR_BTNTEXT));
	int hh = 0;
	if (m_lTextLines != 0) hh = cr.Height() / m_lTextLines;
	cr1.right = cr1.left + m_lTextWidth;
	dc.FillRect(cr1, & CBrush(GetSysColor(COLOR_BTNFACE)));
	cr1.bottom = cr1.top + hh;
	CFont* pOldFont = dc.SelectObject(GetFont());
	for (int i = 0; i < m_lTextLines; i++)
	{
		dc.DrawText(text[i], (LPRECT)&cr1,
		DT_WORDBREAK | DT_CENTER | DT_VCENTER);
		cr1.OffsetRect(0, hh);
	}
	dc.SelectObject(pOldFont);
// graph
	if (m_dMaxValue == 0) return;
	if (m_bTextLeft) cr.left += m_lTextWidth;
	else cr.right -= m_lTextWidth;
	cr1 = cr;
	if (m_bMotionLToR) cr1.right = cr1.left + 2;
	else cr1.left = cr1.right - 2;
	i = m_lStack;
	cr1.bottom -= 1;
	int h = cr.Height() - 2;
	while (TRUE)
	{
		int h1 = 0;
		if (m_dMaxValue != 0) h1 = (int)((DOUBLE) h * myHistogram[i] / m_dMaxValue);
		if (h1 > h) h1 = h;
		cr1.top = cr.top;
		cr1.bottom = cr.bottom - h1;
		dc.FillRect(cr1, & CBrush(GetSysColor(COLOR_BTNFACE)));
		cr1.top = cr.bottom - h1;
		cr1.bottom = cr.bottom;
		dc.FillRect(cr1, & CBrush(GetSysColor(COLOR_BTNHIGHLIGHT)));
		if (m_bMotionLToR) cr1.OffsetRect(3, 0);
		else cr1.OffsetRect(-3, 0);
		if (i == 0) i = m_lArraySize;
		i--;
		if (m_bMotionLToR)
		{
			if (cr1.left > cr.right - 3) break;
		}
		else
		{
			if (cr1.left < cr.left) break;
		}
	}
}

BOOL CAlexfStaticHistogram::Add(DOUBLE dValue)
{
	m_lStack++;
	if (m_lStack >= m_lArraySize) m_lStack = 0;  // This reads the random numbers from 
	myHistogram[m_lStack] = dValue;				 // the array and then calls the function to
	RedrawWindow();								 // draw the graph.
	return TRUE;
}



